<?php

declare(strict_types=1);

namespace Dedi\SyliusContactPlugin\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity()
 * @ORM\Table(name="dedi_sylius_contact_attachment")
 */
class Attachment implements AttachmentInterface
{
    /**
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id()
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected ?int $id;

    /**
     * @ORM\Column(name="path", type="string")
     */
    protected ?string $path;

    /**
     * @ORM\ManyToOne(targetEntity="Dedi\SyliusContactPlugin\Entity\ContactFormMessage", inversedBy="attachments")
     * @ORM\JoinColumn(name="contact_form_message_id", referencedColumnName="id")
     */
    protected ?ContactFormMessageInterface $contactFormMessage;

    /**
     * @ORM\ManyToOne(targetEntity="Dedi\SyliusContactPlugin\Entity\Answer", inversedBy="attachments")
     * @ORM\JoinColumn(name="answer_id", referencedColumnName="id")
     */
    protected ?AnswerInterface $answer;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getPath(): ?string
    {
        return $this->path;
    }

    public function setPath(?string $path): AttachmentInterface
    {
        $this->path = $path;

        return $this;
    }

    public function getContactFormMessage(): ContactFormMessageInterface
    {
        return $this->contactFormMessage;
    }

    public function setContactFormMessage(?ContactFormMessageInterface $contactFormMessage): AttachmentInterface
    {
        $this->contactFormMessage = $contactFormMessage;

        return $this;
    }

    public function getAnswer(): ?AnswerInterface
    {
        return $this->answer;
    }

    public function setAnswer(?AnswerInterface $answer): AttachmentInterface
    {
        $this->answer = $answer;

        return $this;
    }
}
